package com.fuyuanshen.app.service.impl;

import com.fuyuanshen.app.service.IAppMenuService;
import com.fuyuanshen.app.service.IAppPermissionService;
import com.fuyuanshen.app.service.IAppRoleService;
import com.fuyuanshen.common.core.constant.TenantConstants;
import com.fuyuanshen.common.core.service.AppPermissionService;
import com.fuyuanshen.common.core.service.PermissionService;
import com.fuyuanshen.common.satoken.utils.LoginHelper;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Set;

/**
 * 用户权限处理
 *
 * @author fys
 */
@RequiredArgsConstructor
@Service
public class AppPermissionServiceImpl implements IAppPermissionService, AppPermissionService {

    private final IAppRoleService roleService;
    private final IAppMenuService menuService;

    /**
     * 获取角色数据权限
     *
     * @param userId  用户id
     * @return 角色权限信息
     */
    @Override
    public Set<String> getRolePermission(Long userId) {
        Set<String> roles = new HashSet<>();
        // 管理员拥有所有权限
        if (LoginHelper.isSuperAdmin(userId)) {
            roles.add(TenantConstants.SUPER_ADMIN_ROLE_KEY);
        } else {
            roles.addAll(roleService.selectRolePermissionByUserId(userId));
        }
        return roles;
    }

    /**
     * 获取菜单数据权限
     *
     * @param userId  用户id
     * @return 菜单权限信息
     */
    @Override
    public Set<String> getMenuPermission(Long userId) {
        Set<String> perms = new HashSet<>();
        // 管理员拥有所有权限
        if (LoginHelper.isSuperAdmin(userId)) {
            perms.add("*:*:*");
        } else {
            perms.addAll(menuService.selectMenuPermsByUserId(userId));
        }
        return perms;
    }
}
